package JHamlConverter;

import java.io.*;
import java.util.*;
import java.util.regex.Pattern;

import static JHamlConverter.DebugAndTest.debug;
import static JHamlConverter.HelperMethods.*;

public class DirectMethods {

    /**
     * Method that Populates lists with the to be converted / used files
     * @param filePath - filepath to read a specific document
     * @return newList - Arraylist<String>
     */
    public static ArrayList<String> PopulateList(String filePath) throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader(filePath));
        ArrayList<String> newList = new ArrayList<>();
        String line;

        while((line = reader.readLine()) != null) {
            newList.add(line);
        }
        return newList;
    }

    /**
     * @param line - current to be converted line
     * @return charIndex - integer
     */
    public static int indexOfChar(String line) {
        int charIndex = 0;

        for(int i = 0;i < line.length();i++){
            if(!Character.isWhitespace(line.charAt(i))){
                charIndex = i;
                break;
            }
        }
        return charIndex;
    }

    /**
     * Method that creates all the tag details
     * @param line - a string where we need to make the correct tag find the ('elements' = rest) and ('value' = txt)
     * @param indentation - integer value of the indentation of current line
     * @return String[] - String [] with tag rest and txt values
     */
    public static String[] createTagDetails(String line, int indentation, FileWriter writer,String type) throws IOException {
        int amountOfClasses;
        String rest = "";
        String txt = "";
        String[] tagParts;
        String[] endParts = new String[3];
        String tag = "";
        String[] classes;
        char startingChar = getFirstChar(line);
        ArrayList<String> tagPartsContainer;
        tagPartsContainer = new ArrayList<>();
        int endTagIndex = getEndTagIndex(line, indentation);

        if(startingChar == '%') {
            //if tag has rest or txt or both
            if (endTagIndex != line.length()) {
                rest = line.substring(endTagIndex);

                if (line.charAt(line.length() - 1) == ')') {
                    rest = rest.substring(1, rest.length() - 1);
                }
                else if (rest.charAt(0) == '.') {
                    ArrayList<String> classesArrList = new ArrayList<>();

                    if (rest.contains(" ")) {
                        tagParts = rest.split(" ");

                        for (int i = 1; i < tagParts.length; i++) {
                            txt += tagParts[i];

                            if (i < tagParts.length - 1) {
                                txt += " ";
                            }
                        }
                        amountOfClasses = tagParts[0].split("\\.").length;
                        Collections.addAll(classesArrList, tagParts[0].split("\\."));

                    } else {
                        amountOfClasses = rest.split("\\.").length;
                        Collections.addAll(classesArrList, rest.split("\\."));
                    }
                    classes = new String[amountOfClasses];

                    for (int i = 0; i < classesArrList.size(); i++) {
                        classes[i] = classesArrList.get(i);
                    }
                    rest = "class=\"";

                    for (int i = 1; i < classes.length; i++) {
                        if (i != classes.length - 1) {
                            rest += classes[i] + " ";
                        } else {
                            rest += classes[i];
                        }
                    }
                    rest += "\"";
                } else if (rest.charAt(0) == ' ') {
                    tagParts = rest.split(" ");
                    rest = "";
                    txt = "";
                    for (int i = 1; i < tagParts.length; i++) {
                        txt += tagParts[i];

                        if (i < tagParts.length - 1) {
                            txt += " ";
                        }
                    }
                } else if (rest.charAt(0) == '#') {

                    if (rest.contains(" ")) {
                        tagParts = rest.split(" ");

                        for (int i = 1; i < tagParts.length; i++) {
                            txt += tagParts[i];

                            if (i < tagParts.length - 1) {
                                txt += " ";
                            }
                        }
                        Collections.addAll(tagPartsContainer, tagParts[0].split("\\."));
                    } else {
                        Collections.addAll(tagPartsContainer, rest.split("\\."));
                    }
                    rest = "id=\"" + tagPartsContainer.get(0).substring(1) + "\"";
                }
            }
            // if it has no rest or txt
            tag = "<";
            if (indentation + 1 == endTagIndex) {
                tag += "div";
                if(line.substring(indentation).contains(" ")){}

                else{
                    type = "depth";
                }
            }
            else if (line.charAt(line.length() - 1) == '/') {
                tag += line.substring(indentation + 1,line.length()-1);
                rest = "";
                txt = "";
            } else {
                tag += line.substring(indentation + 1, endTagIndex);

            }
        }
        else if(startingChar == '\\'){
            tag = line.substring(indentation+1);
            rest = "";
            txt = "";
        }
        else if(startingChar == '-'){
            tag = "";
            rest = "";
            txt = "";
        }
        else if (startingChar == '/'){
            tag = "<!--" ;
            rest = "";
            txt = line.substring(indentation+1);
        }
        else if (startingChar == '#'){
            tag = "<div";
            if(line.substring(indentation).contains(" ")){
                rest = "id=\"" + line.substring(indentation+1,indentation + line.substring(indentation).indexOf(" ")) + "\"";
                txt = line.substring(indentation+1+line.substring(indentation).indexOf(" "));
            }
            else{
                rest = "id=\"" + line.substring(indentation+1) + "\"";
                txt ="";
                type = "depth";
            }
        }
        else if (startingChar == '.'){
            tag = "<div";
            rest = line.substring(indentation);
            ArrayList<String> classesArrList = new ArrayList<>();
            if (rest.contains(" ")) {
                tagParts = rest.split(" ");

                for (int i = 1; i < tagParts.length; i++) {
                    txt += tagParts[i];

                    if (i < tagParts.length - 1) {
                        txt += " ";
                    }
                }
                amountOfClasses = tagParts[0].split("\\.").length;
                Collections.addAll(classesArrList, tagParts[0].split("\\."));

            } else {
                amountOfClasses = rest.split("\\.").length;
                Collections.addAll(classesArrList, rest.split("\\."));
                type = "depth";
            }
            classes = new String[amountOfClasses];

            for (int i = 0; i < classesArrList.size(); i++) {
                classes[i] = classesArrList.get(i);
            }
            rest = "class=\"";

            for (int i = 1; i < classes.length; i++) {
                if (i != classes.length - 1) {
                    rest += classes[i] + " ";
                } else {
                    rest += classes[i];
                }
            }
            rest += "\"";
        }
        else {
            tag = line.substring(indentation);
            rest = "";
            txt = "";
            type = "depth";
        }
        endParts[0] = tag;
        endParts[1] = rest;
        endParts[2] = txt;
        writeToFile(indentation ,tag ,rest ,txt ,writer, type);

        return endParts;
    }

    /**
     * Method that checks how many 'children' a headParent has
     * @param lines - The to be converted document represented by lines (each index = 1 line (Arraylist<String>))
     * @param parentLine - current headParent line
     * @return childrenElements - integer value that gives the exact amount of children of the current headParent
     */
    public static int getChildrenElements(ArrayList<String> lines, String parentLine, int lineCounter) {
        int parentIndex = getParentLine(lines, parentLine, lineCounter);
        int childrenElements = 0;
        int childIndentation = 0;
        int parentIndentation = indexOfChar(lines.get(parentIndex));
        int maxLines = lines.size();

        if(parentIndex + 1 < maxLines){
            childIndentation = indexOfChar(lines.get(parentIndex +1));
        }

        while(childIndentation > parentIndentation){
            childrenElements++;
            if((parentIndex +1 + childrenElements) < maxLines) {
                childIndentation = indexOfChar(lines.get(parentIndex+1+childrenElements));

            }
            else { // END OF FILE (EOF)
                break;
            }
        }
        return childrenElements;
    }
}
