package JHamlConverter;

import java.io.*;
import java.util.*;

import static JHamlConverter.DirectMethods.*;
import static JHamlConverter.HelperMethods.*;
import static JHamlConverter.DebugAndTest.*;

public class JhamlConverter {



    /**
     * Method that converts Jhaml to HTML via use of other Methods
     * @param fileWriter
     * @param filePathJhaml
     * @throws IOException
     */
    public static void ConvertJhaml(FileWriter fileWriter, String filePathJhaml) throws IOException {
        ArrayList<String> Jhaml = makeLists(filePathJhaml);

        int lineCounter = 0;
        String line = Jhaml.get(lineCounter);
        int htmlIndentation = indexOfChar(line);
        int counter = 0;
        int headParentsIndentation;
        int childrenElements;
        int childrenIndent;

        String nextLine;
        String parentTag;
        String childtag;
        String [] lineParts;
        lineParts = createTagDetails(line, htmlIndentation, fileWriter,"depth");
        String htmlTag = lineParts[0];
        lineCounter++;

        try {
            while (counter < 2) {
                //loopîng headParents
                nextLine = Jhaml.get(lineCounter);
                headParentsIndentation = indexOfChar(nextLine);
                lineParts = createTagDetails(nextLine, headParentsIndentation, fileWriter, "depth");
                parentTag = lineParts[0];
                lineCounter++;
                childrenElements = getChildrenElements(Jhaml, nextLine, lineCounter);

                for(int i = 0; i < childrenElements; i++){
                    //looping through the children of Head-HeadParent
                    if(counter == 0){

                    nextLine = Jhaml.get(lineCounter);
                    childrenIndent = indexOfChar(nextLine);
                    createTagDetails(nextLine, childrenIndent, fileWriter,"");
                    childtag = lineParts[0];
                    lineCounter++;
                    }
                    //looping through the children of the Body-HeadParent
                    else{
                        lineCounter = parseTags(Jhaml.get(lineCounter), nextLine, lineCounter, Jhaml,fileWriter);

                        if(lineCounter == Jhaml.size()){
                            break;
                        }
                    }
                }

                counter++; // increment headParents
                //END-HeadParents-TAG
                fileWriter.write(createSpace(headParentsIndentation) + makeEndTag(parentTag) + "\n");
            }
                //END-HTML-TAG-With-Children
                fileWriter.write(createSpace(htmlIndentation) + makeEndTag(htmlTag));

        } catch (IndexOutOfBoundsException exception) {
                //END-HTML-TAG-With-No-Children
            exception.printStackTrace();
        }
    }
}