package JHamlConverter;

import org.junit.jupiter.api.Test;
import java.io.*;
import java.nio.charset.Charset;
import java.util.*;
import org.apache.commons.io.FileUtils;
import static org.junit.jupiter.api.Assertions.assertEquals;
import java.io.FileWriter;



class JhamlConverterTest {
    static final String filePathJhamlTestForTest ="src/main/resources/JhamlTestForTest.txt";
    static final String filePathHtmlexpected = "src/test/java/JHamlConverter/JhamlConverterTest.java";
    static final String fileJHamlOutput = "src/main/resources/JhamlTestOutput.html";

    ArrayList<String> ListofJhamlTestForTest = DirectMethods.PopulateList(filePathJhamlTestForTest);
    ArrayList<String> JhamlCoverterTestList = DirectMethods.PopulateList(filePathHtmlexpected);
    ArrayList<String> JhamlTestOutputList = DirectMethods.PopulateList(fileJHamlOutput);



    JhamlConverterTest() throws IOException {
    }


    @Test
    void ConvertJhaml() throws IOException{
       JhamlConverter ConvertJhaml = new JhamlConverter();
        FileWriter fileWritertest = new FileWriter(fileJHamlOutput);
        JhamlConverter.ConvertJhaml(fileWritertest, filePathJhamlTestForTest);
        fileWritertest.close();
        BufferedReader htmlReader = new BufferedReader(new FileReader("src/main/resources/JHamlTestoutput.html"));
        //DebugAndTest.TestPrint(htmlReader);
        final File expected = new File("src/main/resources/JHamlexpected.html");
        final File output = new File("src/main/resources/JhamlTestOutput.html");
        assertEquals(FileUtils.readLines(expected, Charset.defaultCharset()), FileUtils.readLines(output,Charset.defaultCharset()));


    }

    @Test
    void createSpace() {
        assertEquals("",HelperMethods.createSpace(0));
        assertEquals("  ",HelperMethods.createSpace(2));
        assertEquals("    ",HelperMethods.createSpace(4));
    }

    @Test
    void getEndTagIndex() {
        assertEquals(5,HelperMethods.getEndTagIndex("%html(lang=\"en\")", 0));
        assertEquals(7,HelperMethods.getEndTagIndex("  %head", 2));
        assertEquals(9,HelperMethods.getEndTagIndex("    %meta(charset=\"UTF-8\")", 4));
        assertEquals(10,HelperMethods.getEndTagIndex("    %title TeamRed", 6));
        assertEquals(7,HelperMethods.getEndTagIndex("    %li Gregory", 4));
        assertEquals(9,HelperMethods.getEndTagIndex("      %li Geoffrey", 6));
        assertEquals(11,HelperMethods.getEndTagIndex("        %li Winnie", 8));
        assertEquals(7,HelperMethods.getEndTagIndex("    %li Christy", 4));
        assertEquals(7,HelperMethods.getEndTagIndex("  %body", 2));
        assertEquals(5,HelperMethods.getEndTagIndex("    %.eight.wide", 4));
        assertEquals(7,HelperMethods.getEndTagIndex("      %#anid", 6));
    }

    @Test
    void createTagDetails() {


    }

    @Test
    void testPrint() {
    }
}

